/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: CryptoPlugin.java 9137 2006-09-27 01:41:57Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applications.signerclient.crypto;

import java.io.File;

/**
 * @version $Rev: 9137 $ $Date: 2006-09-27 08:41:57 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public interface CryptoPlugin {

	Object loadKeyStore(File ksFile, String ksPassword, String ksType) throws CryptoException;

	Object getPrivateKey(Object keyStore, String ksPassword) throws CryptoException;

	byte[] sign(byte[] hash, String algorithm, Object privateKey) throws CryptoException;

	Object[] getCertificationChain(Object keyStore) throws CryptoException;

    byte[] getCertPath(Object[] certChain, String type) throws CryptoException;
}
