package org.exoplatform.portlets.content.actions.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.PropertyType;
import javax.jcr.Value;

import org.exoplatform.faces.cms.CMSDelegate;
import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.actions.ActionServiceContainer;
import org.exoplatform.services.grammar.wiki.WikiContext;
import org.exoplatform.services.grammar.wiki.WikiEngineService;

public class UIActionView extends UIExoCommand{
  public static Parameter[] BACK_PARAMS = { new Parameter(ACTION , BACK_ACTION)} ;  
  private CMSDelegate delegate;
  private ActionServiceContainer container_;

  public UIActionView(ActionServiceContainer container) {
    setId("UIActionView") ;
    setRendererType("SimpleFormVelocityRenderer");    

    container_ = container;

    addActionListener(BackActionListener.class, BACK_ACTION);
  }
  public Parameter[] getBackParams() {
    return BACK_PARAMS ; 
  }

  public void editMove(Node node, String name) throws Exception {
    Node anode = container_.getAction(node, name);
    delegate = new CMSDelegate(anode);    
  }  

  public Node getNode() throws Exception{
    return delegate.getNode();
  }

  public void setNode(Node node){
    delegate.setNode(node);
  }  

  public String getPortalName() {
    return delegate.getPortalName();
  }

  public String getWorkspaceName() throws Exception {
    return delegate.getWorkspaceName();
  }  

  public boolean isNodeTypeSupported() {
    return delegate.isNodeTypeSupported();
  }  

  public WikiContext getWikiContext() {
    return delegate.getWikiContext();
  }

  public WikiEngineService getWikiService() {
    return delegate.getWikiService();
  }    

  public String getNodeType() throws Exception {
    return delegate.getNodeType();
  }

  public String getTemplatePath() throws Exception {
    return delegate.getTemplatePath();
  }

  public List<String> getMultivalueAsListString(Node node,String property) throws Exception {
    List<String> values = new ArrayList<String>() ;
    if(!node.hasProperty(property)) return values ;
    Property prop = node.getProperty(property) ;
    int type = prop.getType() ;
    if(type == PropertyType.REFERENCE || type == PropertyType.BINARY || type == PropertyType.UNDEFINED)
      return values ;
    if(prop.getDefinition().isMultiple()) {
      for(Value value:prop.getValues()) 
        values.add(value.getString()) ;
    }else 
      values.add(prop.getValue().getString()) ;
    return values ;
  }

  static public class BackActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {      
      UIActionView uicomp = (UIActionView) event.getSource();
      ((UIExoComponent)uicomp.getParent()).setRenderedSibling(UIActionList.class);      
    }
  }    

}
