package org.exoplatform.portlets.content.contentbrowser.component;

import java.util.List;

import javax.jcr.nodetype.NodeType;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.services.cms.templates.TemplateService;
import org.exoplatform.services.jcr.RepositoryService;

public class CBUtils {    

  final public static String USECASE = "usecase".intern() ;
  final public static String FORM_PATH = "From Path".intern() ;
  final public static String USE_DOCUMENT = "Document".intern() ;
  final public static String USE_JCR_QUERY = "Using a JCR query".intern() ;
  final public static String USE_SCRIPT = "Using a script".intern() ;  

  final public static String WORKSPACE = "workspace".intern() ;   
  final public static String JCR_PATH = "path".intern() ;
  final public static String DOCUMENT_NAME = "documentName".intern() ;
  final public static String SCRIPT_NAME = "scriptName".intern() ;

  final public static String REF_DOCUMENT= "reference".intern() ;  
  final public static String CHILD_DOCUMENT = "child".intern();

  final public static String QUERY_STATEMENT = "queryStatement".intern() ;
  final public static String QUERY_STORE = "queryStore".intern() ;
  final public static String QUERY_LANGUAGE = "queryLanguage".intern() ;

  final public static String NB_PER_PAGE = "nbPerPage".intern() ;
  final public static String VIEW_TOOLBAR = "viewToolbar".intern(); 
  final public static String BOX_TEMPLATE = "boxTemplate".intern();   
  final public static String TEMPLATE = "template".intern();
  final public static String VIEW_TAGS_CLOUD = "viewTagsCloud".intern() ;
  final public static String ALLOW_VOTING = "allowVoting".intern() ;
  final public static String ALLOW_COMMENT = "allowComment".intern() ;
  final public static String IS_NEW_QUERY = "isNewQuery".intern() ;
  final public static String IS_PERSONAL_QUERY = "isPersonalQuery".intern() ;
  final public static String ALLOW_EXPORTING = "allowExporting".intern() ;

  final public static String[] CATEGORY_NODE_TYPES = {"nt:folder","nt:unstructured","exo:taxonomy"} ;     
  final public static String EXO_RELATION_PROP = "exo:relation".intern() ;  
  final public static String NT_FILE = "nt:file".intern() ;
  final public static String MIX_REFERENCEABLE = "mix:referenceable".intern() ;  

  final public static String SEMI_COLON = ";".intern() ;
  final public static String COLON = ":".intern() ;
  final public static String SLASH = "/".intern() ;

  public static boolean isDocument(NodeType nodeType) throws Exception{
    TemplateService templateService = 
      (TemplateService)PortalContainer.getComponent(TemplateService.class) ;    
    List listDocumentNodeType = templateService.getDocumentTemplates() ;
    String name = nodeType.getName() ;
    if(listDocumentNodeType.contains(name)) return true ;
    return false ;
  }

  public static String[] getWorkspaceNames() throws Exception {
    RepositoryService repositoryService = 
      (RepositoryService) PortalContainer.getComponent(RepositoryService.class) ;
    return repositoryService.getRepository().getWorkspaceNames() ;
  }
}
