/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.contentbrowser.component;

import java.util.ArrayList;
import java.util.List;

import javax.portlet.PortletPreferences;

import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

/**
 * Created by The eXo Platform SARL
 * Author : HoaPham
 hoa.pham@exoplatform.com
 *          phamvuxuanhoa@yahoo.com
 * May 3, 2006
 */

public class UINewConfigForm extends UISimpleForm {    
  protected UISelectBox workspaces_ ;  
  private UISelectBox usecase_ ;
  
  public UINewConfigForm() throws Exception {    
    super("NewConfigForm","post",null) ;   
    setId("NewConfigForm") ;
    setRendererType("SimpleFormVelocityRenderer");
    
    String[] workspaceNames = CBUtils.getWorkspaceNames() ;    
    List<SelectItem> workspaceOptions = new ArrayList<SelectItem>() ;    
    for(String workspace:workspaceNames) {
      workspaceOptions.add(new SelectItem(workspace,workspace)) ;
    }   
    workspaces_ = new  UISelectBox(CBUtils.WORKSPACE, "", workspaceOptions) ;
    add(workspaces_);
    
    List<SelectItem> loadSelection = new ArrayList<SelectItem>() ;
    loadSelection.add(new SelectItem(CBUtils.FORM_PATH, CBUtils.FORM_PATH)) ;
    loadSelection.add(new SelectItem(CBUtils.USE_JCR_QUERY, CBUtils.USE_JCR_QUERY)) ;
    loadSelection.add(new SelectItem(CBUtils.USE_SCRIPT,CBUtils.USE_SCRIPT)) ;
    loadSelection.add(new SelectItem(CBUtils.USE_DOCUMENT,CBUtils.USE_DOCUMENT)) ;
    usecase_ = new UISelectBox(CBUtils.USECASE,"", loadSelection) ;
    add(usecase_) ;    
    
    addActionListener(NextActionListener.class,SAVE_ACTION) ;
    addActionListener(CancelActionListener.class,CANCEL_ACTION) ;
  }
  
  public static class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINewConfigForm newConfigForm = (UINewConfigForm)event.getComponent() ;
      PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
      String usecase = prefs.getValue(CBUtils.USECASE,"") ;
      if(usecase.equals(CBUtils.FORM_PATH)) {
        UIPathConfig pathConfig = (UIPathConfig)newConfigForm.getSibling(UIPathConfig.class) ;
        pathConfig.setEditable(false) ;
        newConfigForm.setRenderedSibling(UIPathConfig.class) ;
      }else if(usecase.equals(CBUtils.USE_JCR_QUERY)) {
        UIQueryConfig queryConfig = (UIQueryConfig)newConfigForm.getSibling(UIQueryConfig.class) ;
        queryConfig.setEditable(false) ;
        newConfigForm.setRenderedSibling(UIQueryConfig.class) ;
      }else if(usecase.equals(CBUtils.USE_SCRIPT)) {
        UIScriptConfig scriptConfig = (UIScriptConfig)newConfigForm.getSibling(UIScriptConfig.class) ;
        scriptConfig.setEditable(false) ;
        newConfigForm.setRenderedSibling(UIScriptConfig.class) ;
      } else if (usecase.equals(CBUtils.USE_DOCUMENT)) {
        UIDocumentConfig documentConfig = (UIDocumentConfig)newConfigForm.getSibling(UIDocumentConfig.class) ;
        documentConfig.setEditable(false) ;
        newConfigForm.setRenderedSibling(UIDocumentConfig.class) ;
      }
    }    
  }
  
  public static class NextActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UINewConfigForm newConfigForm = (UINewConfigForm)event.getComponent() ;
      String usecase = newConfigForm.getUIInput(CBUtils.USECASE).getValue() ;          
      String workspace = newConfigForm.getUIInput(CBUtils.WORKSPACE).getValue() ;      
      if(usecase.equals(CBUtils.FORM_PATH)) {        
        UIPathConfig pathConfig = (UIPathConfig)newConfigForm.getSibling(UIPathConfig.class) ;
        pathConfig.setEditable(true) ;
        pathConfig.setChangedForm(true) ;
        pathConfig.workspaces_.setValue(workspace) ;
        pathConfig.workspaces_.setEditable(false) ;
        pathConfig.updateSelectBoxes() ;
        newConfigForm.setRenderedSibling(UIPathConfig.class) ;
      }else if(usecase.equals(CBUtils.USE_JCR_QUERY)) {
        UIQueryConfig queryConfig  = (UIQueryConfig)newConfigForm.getSibling(UIQueryConfig.class) ;
        queryConfig.setEditable(true) ;
        queryConfig.setChangedForm(true) ;
        queryConfig.workspaces_.setValue(workspace) ;
        queryConfig.workspaces_.setEditable(false) ;
        queryConfig.updateSelectBoxes() ;
        newConfigForm.setRenderedSibling(UIQueryConfig.class) ;
      }else if(usecase.equals(CBUtils.USE_SCRIPT)) {
        UIScriptConfig scriptConfig = (UIScriptConfig)newConfigForm.getSibling(UIScriptConfig.class) ;
        scriptConfig.setEditable(true) ;
        scriptConfig.setChangedForm(true) ;
        scriptConfig.updateSelectBoxes() ;
        scriptConfig.workspaces_.setValue(workspace) ;
        scriptConfig.workspaces_.setEditable(false) ;
        newConfigForm.setRenderedSibling(UIScriptConfig.class) ;
      } else if (usecase.equals(CBUtils.USE_DOCUMENT)) {
        UIDocumentConfig documentConfig = (UIDocumentConfig)newConfigForm.getSibling(UIDocumentConfig.class) ;
        documentConfig.setEditable(true) ;
        documentConfig.setChangedForm(true) ;
        documentConfig.updateSelectBoxes() ;
        documentConfig.workspaces_.setValue(workspace) ;
        documentConfig.workspaces_.setEditable(false) ;
        newConfigForm.setRenderedSibling(UIDocumentConfig.class) ;
      }
    }   
  }
}
