/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UIExoCommand;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.folksonomy.component.UILinkedTags;
import org.exoplatform.portlets.content.folksonomy.component.UITaggingForm;

/**
 * Created by The eXo Platform SAS
 * Author : Pham Xuan Hoa
 *          hoa.pham@exoplatform.com
 * Jan 5, 2007  
 */
public class UITaggingController extends UIExoCommand implements ChangeNodeListener {
  
  static Parameter[] CANCEL_PARAMS = { new Parameter(ACTION,CANCEL_ACTION)} ;
  
  public UITaggingController() throws Exception {
    setId("UITaggingController") ;
    setRendererType("VelocityRenderer") ;
    addChild(UILinkedTags.class).setRendered(true) ;
    addChild(UITaggingForm.class).setRendered(true) ;    
    addActionListener(CancelActionListener.class,CANCEL_ACTION) ;
  }
  
  static public class CancelActionListener extends ExoActionListener {    
    public void execute(ExoActionEvent event) throws Exception {
      UITaggingController uicomp = (UITaggingController)event.getSource() ;
      UIViewController controller = (UIViewController)uicomp.getParent().getParent() ;
      UIJCRExplorer explorer = (UIJCRExplorer)controller.getAncestorOfType(UIJCRExplorer.class) ;
      explorer.broadcastOnChange(explorer.getSelectNode()) ;
      uicomp.setRendered(false) ;      
    }    
  }
  
  public Parameter[] getCancelParams() { return  CANCEL_PARAMS ;}
  
  public void setDatas(Node node) throws Exception {    
    UILinkedTags linkedTags = (UILinkedTags)getChildComponentOfType(UILinkedTags.class) ;
    linkedTags.setDocument(node) ;    
  }
  
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    this.setRendered(false) ;
  }
}
