package org.exoplatform.portlets.content.namespace.component;


import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.faces.core.validator.NameValidator;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;

public class UINamespaceRegisterForm extends UISimpleForm{
	final static String PREFIX = "prefix".intern() ;
	final static String URI = "uri".intern() ;
	
	protected UIStringInput prefix_ ;
	protected UIStringInput uri_ ;
	public UINamespaceRegisterForm() {
		super("namespaceRegistryForm","POST",null) ;
		setRendererType("SimpleFormVelocityRenderer");		
		
		prefix_ = new UIStringInput(PREFIX,"") ;
		prefix_.addValidator(NameValidator.class) ;
		add(prefix_) ;
		
		uri_ = new UIStringInput(URI,"") ;
		uri_.addValidator(EmptyFieldValidator.class) ;
		add(uri_) ;
		
		addActionListener(CancelActionListener.class, CANCEL_ACTION);
    addActionListener(SaveActionListener.class, SAVE_ACTION);    
	}
  
  public void setEditState(String uri, String prefix) {
    uri_.setText(uri) ;
    prefix_.setText(prefix) ;
  }
	
	public static class CancelActionListener extends ExoActionListener {		
		public void execute(ExoActionEvent event) throws Exception {	
			UINamespaceRegisterForm uiform = (UINamespaceRegisterForm)event.getComponent() ;
			uiform.setRenderedSibling(UINamespaceRegistry.class) ;
		}		
	}
	
	public static class SaveActionListener extends ExoActionListener {		
		public void execute(ExoActionEvent event) throws Exception {			
			UINamespaceRegisterForm uiform = (UINamespaceRegisterForm)event.getComponent() ;
			String prefix = uiform.getUIInput(PREFIX).getValue() ;
			String uri = uiform.getUIInput(URI).getValue() ;
			Information iprovider = findInformationProvider(uiform) ;
			ResourceBundle res = getApplicationResourceBundle() ;
			UINamespaceRegistry uiregistry = (UINamespaceRegistry)uiform.getSibling(UINamespaceRegistry.class) ;
			try {
				uiregistry.namespaceRegistry_.registerNamespace(prefix,uri) ;
        Object[] args = {prefix} ;
        iprovider.addMessage(
            new ExoFacesMessage(FacesMessage.SEVERITY_INFO,res.getString("UINamspaceRegistry.msg.register-successfull"),args)) ;
			} catch (Exception e) {
				JCRExceptionManager.process(iprovider,e) ;				
				return ;
			}			
			uiform.reset() ;
      uiregistry.refresh();
			uiform.setRenderedSibling(UINamespaceRegistry.class) ;		
		}		
	}
}
