package org.exoplatform.portlets.content.nodetypes.component;

import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.jcr.PropertyType;
import javax.jcr.Value;
import javax.jcr.nodetype.NodeType;
import javax.jcr.nodetype.NodeTypeManager;
import javax.jcr.nodetype.PropertyDefinition;

import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.model.Parameter;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.NameValidator;
import org.exoplatform.portal.Information;
import org.exoplatform.services.jcr.core.nodetype.PropertyDefinitionValue;

public class UIPropertyDefinitionForm extends UISimpleForm {
  
  private static String[] valueTypes = {"UNDEFINED", "STRING", "BINARY", "LONG", "DOUBLE", "DATE",
                                        "BOOLEAN", "NAME", "PATH", "REFERENCES"} ;
  private static String ADD_CONSTRAINTS_ACTION = "addConstraints" ;
  private static String CHANGE_REQUIRED_TYPE_ACTION = "changeType" ;
  private static String DELETE_CONTRAINTS_ACTION = "deleteContraints" ;
  public static Parameter[] DELETE_CONTRAINTS_PARAMS = { new Parameter(ACTION , DELETE_CONTRAINTS_ACTION)} ;
  
  private NodeTypeManager ntManager_ ;
  private List addedConstraints_ = new ArrayList() ;
  private boolean isView_ = false ;
  public static Parameter[] ADD_CONSTRAINTS_PARAMS = { new Parameter(ACTION , ADD_CONSTRAINTS_ACTION)} ;
  public UIPropertyDefinitionForm() {
    super("uiPropertyDefinitionForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");
    UISelectBox namespace = new UISelectBox("namespace","",new ArrayList()) ;
    UIStringInput propertyName = new UIStringInput("propertyname", "") ;
    List<SelectItem> requireType = new ArrayList<SelectItem>();
    requireType.add(new SelectItem("STRING", "1")) ;
    requireType.add(new SelectItem("BINARY", "2")) ;
    requireType.add(new SelectItem("LONG", "3")) ;
    requireType.add(new SelectItem("DOUBLE", "4")) ;
    requireType.add(new SelectItem("DATE", "5")) ;
    requireType.add(new SelectItem("BOOLEAN", "6")) ;
    requireType.add(new SelectItem("NAME", "7")) ;
    requireType.add(new SelectItem("PATH", "8")) ;
    requireType.add(new SelectItem("REFERENCES", "9")) ;
    requireType.add(new SelectItem("UNDEFINED", "0")) ;    
    UISelectBox requiredType = new UISelectBox("requiredType", "0", requireType) ;
    List<SelectItem> booleanItem = new ArrayList<SelectItem>();
    booleanItem.add(new SelectItem("true", "true")) ;
    booleanItem.add(new SelectItem("false", "false")) ;
    UISelectBox multiple = new UISelectBox("multiple", "false", booleanItem) ;
    UISelectBox mandatory = new UISelectBox("mandatory", "false", booleanItem) ;
    UISelectBox autocreated = new UISelectBox("autocreated", "false", booleanItem) ;
    UISelectBox isprotected = new UISelectBox("protected", "false", booleanItem) ;
    UIStringInput valueContraints = new UIStringInput("valueconstraints", "") ;
    UIStringInput defaultValues = new UIStringInput("defaultValues", "") ;
    List<SelectItem> versionItem = new ArrayList<SelectItem>();
    versionItem.add(new SelectItem("COPY", "1")) ;
    versionItem.add(new SelectItem("VERSION", "2")) ;
    versionItem.add(new SelectItem("INITIALIZE", "3")) ;
    versionItem.add(new SelectItem("COMPUTE", "4")) ;
    versionItem.add(new SelectItem("IGNORE", "5")) ;
    versionItem.add(new SelectItem("ABORT", "6")) ;
    UISelectBox parentVersion = new UISelectBox("parentversion", "1", versionItem) ;
    
    propertyName.addValidator(NameValidator.class) ;
    add(namespace) ;
    add(propertyName) ;
    requiredType.setUpdateOnChangeAction(CHANGE_REQUIRED_TYPE_ACTION) ;
    add(requiredType) ;
    add(multiple) ;
    add(mandatory) ;
    add(autocreated) ;
    add(isprotected) ;
    add(parentVersion) ;
    add(valueContraints) ;
    add(defaultValues) ;
    
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
    addActionListener(SaveActionListener.class, SAVE_ACTION);    
    addActionListener(AddActionListener.class, ADD_CONSTRAINTS_ACTION);
    addActionListener(ChangeRequiredTypeActionListener.class,CHANGE_REQUIRED_TYPE_ACTION);
    addActionListener(DeleteContraintsActionListener.class, DELETE_CONTRAINTS_ACTION);
  }
  
  public Parameter[] getDeleteContraintsParams() { return DELETE_CONTRAINTS_PARAMS ;  }
  
  public boolean isView() { return isView_ ; }
  public String getAddConstraintParams() { return ADD_CONSTRAINTS_ACTION ;  }  
  public List getAddedConstraints() { return addedConstraints_ ; }
  public void setAddedConstraints(List constraints ) {
    addedConstraints_ = constraints ;
  }
  
  public void update (NodeType nodeType, String propertyName, 
                      NodeTypeManager ntManager, List namespaces, boolean isView) throws Exception {
    getUISelectBox("namespace").setOptions(namespaces) ;
    if(propertyName != null) {
      PropertyDefinition[] propertyDefinitions = nodeType.getPropertyDefinitions() ;
      for(int i = 0; i < propertyDefinitions.length ; i++){
        String name = propertyDefinitions[i].getName();
        int propertyType = propertyDefinitions[i].getRequiredType() ;
        if(name.equals(propertyName)) {
          if (propertyName.indexOf(":") > -1){
            getUIStringInput("propertyname").setValue(propertyName.substring(propertyName.indexOf(":") + 1)) ;
            getUISelectBox("namespace").setValue(propertyName.substring(0, propertyName.indexOf(":"))) ;
          }else{
            getUIStringInput("propertyname").setValue(propertyName) ;
            getUISelectBox("namespace").setValue("") ;
          }
          String requiredType = Integer.toString(propertyType) ;
          getUISelectBox("requiredType").setValue(requiredType) ;
          getUISelectBox("multiple").setValue(String.valueOf(propertyDefinitions[i].isMultiple())) ;
          getUISelectBox("mandatory").setValue(String.valueOf(propertyDefinitions[i].isMandatory())) ;
          getUISelectBox("autocreated").setValue(String.valueOf(propertyDefinitions[i].isAutoCreated())) ;
          getUISelectBox("protected").setValue(String.valueOf(propertyDefinitions[i].isProtected())) ;
          String[] cons = propertyDefinitions[i].getValueConstraints() ;
          StringBuffer conValues = new StringBuffer() ;
          if(cons != null && cons.length > 0){
            for(int j = 0 ; j < cons.length ; j ++) {
              if(conValues.length() > 0) conValues.append(", ") ;
              conValues.append(cons[j]) ;
            }
          }
          getUIStringInput("valueconstraints").setValue(conValues.toString()) ;
          String parentVersion = Integer.toString(propertyDefinitions[i].getOnParentVersion()) ;
          getUISelectBox("parentversion").setValue(parentVersion) ;
          Value[] defaultValues = propertyDefinitions[i].getDefaultValues() ;
          StringBuffer defaultValue = new StringBuffer() ;
          if(defaultValues!=null && defaultValues.length>0) {
            if(propertyType == PropertyType.BINARY || propertyType == PropertyType.REFERENCE)
              break ;
            for(Value value:defaultValues) {
              defaultValue.append(value.getString());
              defaultValue.append(", ") ;
            }
          }
          getUIStringInput("defaultValues").setValue(defaultValue.toString()) ;
          break ;
        }
      }
      if(isView) {
        getUISelectBox("namespace").setEditable(false) ;
        getUIStringInput("propertyname").setEditable(false) ;
        getUISelectBox("requiredType").setEditable(false) ;
        getUISelectBox("multiple").setEditable(false) ;
        getUISelectBox("mandatory").setEditable(false) ;
        getUISelectBox("autocreated").setEditable(false) ;
        getUISelectBox("protected").setEditable(false) ;
        getUISelectBox("parentversion").setEditable(false) ;
        getUIStringInput("valueconstraints").setEditable(false) ;
        getUIStringInput("defaultValues").setEditable(false) ;
      }
            
    }else{
      refresh() ;      
    }
    ntManager_ = ntManager ;
    isView_ = isView ;
  }
  
  public void updateEdit(PropertyDefinitionValue property, List namespaces) {
    getUISelectBox("namespace").setOptions(namespaces) ;
    String[] name = property.getName().split(":") ;
    getUISelectBox("namespace").setValue(name[0]).setEditable(false) ;
    getUIStringInput("propertyname").setValue(name[1]).setEditable(false) ;
    getUISelectBox("requiredType").setValue(String.valueOf(property.getRequiredType())).setEditable(true) ;
    getUISelectBox("mandatory").setValue(String.valueOf(property.isMandatory())).setEditable(true) ;
    getUISelectBox("multiple").setValue(String.valueOf(property.isMultiple())).setEditable(true) ;
    getUISelectBox("autocreated").setValue(String.valueOf(property.isAutoCreate())).setEditable(true) ;
    getUISelectBox("protected").setValue(String.valueOf(property.isReadOnly())).setEditable(true) ;
    getUISelectBox("parentversion").setValue(String.valueOf(property.getOnVersion())).setEditable(true) ;    
    isView_ = false ;
  }
  
  private void refresh() {
     getUIStringInput("propertyname").setValue("") ;
     getUISelectBox("requiredType").setValue("false") ;
     getUISelectBox("mandatory").setValue("false") ;
     getUISelectBox("multiple").setValue("false") ;
     getUISelectBox("autocreated").setValue("false") ;
     getUISelectBox("protected").setValue("false") ;
     getUISelectBox("parentversion").setValue("1") ;
     
     getUISelectBox("namespace").setEditable(true) ;
     getUIStringInput("propertyname").setEditable(true) ;
     getUISelectBox("requiredType").setEditable(true) ;
     getUISelectBox("mandatory").setEditable(true) ;
     getUISelectBox("multiple").setEditable(true) ;
     getUISelectBox("autocreated").setEditable(true) ;
     getUISelectBox("protected").setEditable(true) ;
     getUISelectBox("parentversion").setEditable(true) ;
     addedConstraints_ = new ArrayList() ;
  }
  
  public static class ChangeRequiredTypeActionListener extends ExoActionListener{    
    public void execute(ExoActionEvent event) throws Exception {
      UIPropertyDefinitionForm uiForm = (UIPropertyDefinitionForm)event.getSource() ;
      uiForm.addedConstraints_ = new ArrayList() ;
    }    
  }
  
  public static class DeleteContraintsActionListener extends ExoActionListener{    
    public void execute(ExoActionEvent event) throws Exception {
      UIPropertyDefinitionForm uiForm = (UIPropertyDefinitionForm)event.getSource() ;
      String contraints = event.getParameter(OBJECTID) ;
      uiForm.addedConstraints_.remove(contraints) ;
    }    
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPropertyDefinitionForm uiForm = (UIPropertyDefinitionForm) event.getSource();
      Information iprovider = findInformationProvider(uiForm);
      ResourceBundle res = getApplicationResourceBundle() ;
      String propertyName ;
      PropertyDefinitionValue propertyInfo = new PropertyDefinitionValue() ;      
      String prefix = uiForm.getUISelectBox("namespace").getValue() ;
      if (prefix != null && prefix.length() > 0 ) 
        propertyName = prefix + ":" + uiForm.getUIStringInput("propertyname").getValue() ;
      else
        propertyName = uiForm.getUIStringInput("propertyname").getValue() ;
      if(propertyName == null || propertyName.length() == 0) {
        iprovider.addMessage(new ExoFacesMessage(FacesMessage.SEVERITY_ERROR ,
            res.getString("UIPropertyDefinitionForm.msg.property-name"))) ;
        return ;
      }
      propertyInfo.setName(propertyName) ;      
      int requiredType = Integer.parseInt(uiForm.getUISelectBox("requiredType").getValue()) ;
      propertyInfo.setRequiredType(requiredType) ;      
      propertyInfo.setMultiple(Boolean.parseBoolean(uiForm.getUISelectBox("multiple").getValue())) ;
      propertyInfo.setMandatory(Boolean.parseBoolean(uiForm.getUISelectBox("mandatory").getValue())) ;
      propertyInfo.setAutoCreate(Boolean.parseBoolean(uiForm.getUISelectBox("autocreated").getValue())) ;
      propertyInfo.setReadOnly(Boolean.parseBoolean(uiForm.getUISelectBox("protected").getValue())) ;
      int onParent = Integer.parseInt(uiForm.getUISelectBox("parentversion").getValue()) ;
      propertyInfo.setOnVersion(onParent) ;      
      propertyInfo.setValueConstraints(uiForm.addedConstraints_) ;
      UINodeTypeForm nodeTypeForm = (UINodeTypeForm)uiForm.getSibling(UINodeTypeForm.class) ;
      nodeTypeForm.addNewPropertyDefinition(propertyInfo) ;
      uiForm.setRenderedSibling(UINodeTypeForm.class) ;
    }
  }
  
  static public class AddActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPropertyDefinitionForm uiForm = (UIPropertyDefinitionForm) event.getSource();
      String requiredType = uiForm.getUISelectBox("requiredType").getValue() ;
      if(Integer.parseInt(requiredType) == PropertyType.STRING){
        UIValueConstraintsForm valueConstraints = (UIValueConstraintsForm) uiForm.getSibling(UIValueConstraintsForm.class) ;
        valueConstraints.update(uiForm.addedConstraints_) ;
        uiForm.setRenderedSibling(UIValueConstraintsForm.class) ;
      }else if(Integer.parseInt(requiredType) == PropertyType.REFERENCE) {
        UISelectNodeType uiSelect = (UISelectNodeType) uiForm.getSibling(UISelectNodeType.class) ;
        uiSelect.update(uiForm.ntManager_, uiForm.addedConstraints_) ;
        uiForm.setRenderedSibling(UISelectNodeType.class) ;
      }else {
        Information iprovider = findInformationProvider(uiForm);
        ResourceBundle res = getApplicationResourceBundle() ;
        String[] type = {uiForm.valueTypes[Integer.parseInt(requiredType)]} ;
        iprovider.addMessage(new ExoFacesMessage(            
            res.getString("UIPropertyDefinitionForm.msg.not-supported-value-constraints"), type)) ;
        return ;
      }
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIPropertyDefinitionForm uiForm = (UIPropertyDefinitionForm) event.getSource();
      uiForm.setRenderedSibling(UINodeTypeForm.class) ;
    }
  }
  
  
}
