package org.exoplatform.portlets.content.taxonomy.component;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.faces.core.validator.EmptyFieldValidator;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;

/**
 * Created by The eXo Platform SARL
 * Author : HoaPham
 *          phamvuxuanhoa@yahoo.com
 */

public class UITaxonomyForm extends UISimpleForm {				
	
	protected UIStringInput nameInput_ ;				
	protected Node parent_ ;	
	
	public UITaxonomyForm() throws Exception{
		super("taxonomyForm","post",null) ;
		setRendererType("SimpleFormVelocityRenderer");
		
		nameInput_ = new UIStringInput("name","") ;
		nameInput_.addValidator(EmptyFieldValidator.class) ;	
		add(nameInput_) ;
		
		addActionListener(SaveActionListener.class,SAVE_ACTION) ;
		addActionListener(CancelActionListener.class,CANCEL_ACTION) ;
		
	}					
  
	public static class SaveActionListener extends ExoActionListener {		
		public void execute(ExoActionEvent event) throws Exception {		
			UITaxonomyForm uiform = (UITaxonomyForm)event.getComponent() ;
			Information iprovider = findInformationProvider(uiform);
			String name = uiform.getUIInput("name").getValue() ;								
			UITaxonomyManager uiexplorer = (UITaxonomyManager)uiform.getSibling(UITaxonomyManager.class) ;				
			try {								
				Node parent = uiexplorer.getSelectedTaxonomy().getNode() ;					
				uiexplorer.categoriesService_.addTaxonomy(parent.getPath(),name) ;
			}catch (Exception ex) {				
				JCRExceptionManager.process(iprovider, ex);					
				return ;
			}									
			uiexplorer.update();
			uiform.setRenderedSibling(UITaxonomyManager.class) ;
		} 
		
	}
	
	public static class CancelActionListener extends ExoActionListener {
		public void execute(ExoActionEvent event) throws Exception {
			UITaxonomyForm uiform = (UITaxonomyForm)event.getComponent() ;
			uiform.setRenderedSibling(UITaxonomyManager.class) ;
		}		
	}
}