/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.templates.component;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UIExoComponentBase;
import org.exoplatform.services.cms.templates.TemplateService;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: UIRuleFormController.java,v 1.0 2006/08/20 11:11:14 dunghoang Exp $
 */

public class UITemplateFormController extends UIExoComponentBase {
  protected TemplateService templateService_;
  protected Node node_;
  public UITemplateFormController(TemplateService templateService) throws Exception {
    templateService_ = templateService;    
    setRendererType("ChildrenRenderer") ;
    addChild(UISelectTemplateVersionForm.class) ;
    addChild(UITemplateForm.class) ;    
  }
 
  public void showEditTemplateForm(boolean isDialog, String nodeType, String templateName) throws Exception {        
    UISelectTemplateVersionForm uiSelect = 
      (UISelectTemplateVersionForm) getChildComponentOfType(UISelectTemplateVersionForm.class);
    node_ = templateService_.getTemplateNode(isDialog, nodeType, templateName);  
    boolean isVersioned = node_.isNodeType("mix:versionable");
    if (isVersioned) {
      uiSelect.setRendered(true) ; 
      uiSelect.editTemplate(isDialog, nodeType, templateName);  
    }else{
      uiSelect.setRendered(false) ;
    }      
    UITemplateForm templateForm = (UITemplateForm) getChildComponentOfType(UITemplateForm.class);
    templateForm.editTemplate(isDialog, nodeType, templateName, null);       
  }

  public void showNewTemplateForm(boolean isDialog, String nodeType) throws Exception {
    UISelectTemplateVersionForm uiSelect = 
      (UISelectTemplateVersionForm) getChildComponentOfType(UISelectTemplateVersionForm.class);
    uiSelect.setRendered(false) ;
    UITemplateForm templateForm = 
      (UITemplateForm) getChildComponentOfType(UITemplateForm.class);
    templateForm.addTemplate(isDialog, nodeType);
  }
  
}