package org.exoplatform.portlets.content.uploader.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;

import org.exoplatform.faces.cms.CMSUtils;
import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.content.jcr.component.ChangeNodeListener;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;
import org.exoplatform.services.cms.metadata.MetadataService;

public class UIExternalMetadataList extends UISimpleForm implements ChangeNodeListener {  

  private List<String> metadataTypeNames_ ;
  private Node contentNode_ ;
  
  public UIExternalMetadataList(MetadataService metadataService) throws Exception {
    super("extenalMetadataList", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;       
    metadataTypeNames_ = metadataService.getExtenalMetadataType() ;
    for(String metaName: metadataTypeNames_) 
      add(new UICheckBox(metaName,"")) ;              
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
        
  public void update(List<String> seletedList,Node contentNode) throws Exception{  
    this.contentNode_ = contentNode ;
    for(String metaName: metadataTypeNames_) {      
      if(seletedList.contains(metaName))
        getUICheckBox(metaName).setSelect(true) ;
      else
        getUICheckBox(metaName).setSelect(false) ;
      if(contentNode_.isNodeType(metaName)) {
        getUICheckBox(metaName).setSelect(true) ;
        getUICheckBox(metaName).setEditable(false) ;
      }
    }                    
  }

  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {    
    setRendered(false) ;
  }

  public List<String> getMetaTypeNames() { return metadataTypeNames_ ; }

  public String getIcon(String nodeType) {
    return CMSUtils.getIconByNodeTypeName(nodeType) ;
  }

  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIExternalMetadataList uiForm = (UIExternalMetadataList) event.getSource() ;
      uiForm.setRenderedSibling(UIContentUploader.class) ;
    }
  }

  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIExternalMetadataList uiForm = (UIExternalMetadataList) event.getSource() ;      
      UIContentUploader contentUploader = 
        (UIContentUploader)uiForm.getSibling(UIContentUploader.class) ;
      List<String> selectedMetaTypes = new ArrayList<String>() ;      
      for(String name:uiForm.getMetaTypeNames()) {
        if(uiForm.getUICheckBox(name).getSelect()) {
          selectedMetaTypes.add(name) ; 
        }          
      }                             
      contentUploader.setSelectedMetaTypes(selectedMetaTypes) ;
      uiForm.setRenderedSibling(UIContentUploader.class) ;
    }

  }  

}
