package org.exoplatform.portlets.content.versions.component;

import java.util.ArrayList;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.RepositoryException;
import javax.jcr.version.VersionHistory;

import org.exoplatform.faces.core.component.UISelectBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.ChangeNodeListener;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;

public class UIRemoveLabelForm extends UISimpleForm implements ChangeNodeListener {

  protected UISelectBox uiSelect_ ;
  protected Node node_;
  protected VersionHistory vH_;    

  public UIRemoveLabelForm() throws Exception {
    super("UIRemoveLabelForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");

    uiSelect_ = new  UISelectBox("selectLabel", "", null) ;
    add(uiSelect_) ;

    addActionListener(RemoveLabelActionListener.class, SAVE_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }
  
  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    setRendered(false);
  }
 
  public void setVersionHistory(VersionHistory vH) throws RepositoryException {
    vH_ = vH;
    List<SelectItem> options = new ArrayList<SelectItem>();
    String[] labels = vH.getVersionLabels();
    for (int i = 0; i < labels.length; i++) {
      String label = labels[i];
      options.add(new SelectItem(label, label));
    }    
    uiSelect_.setOptions(options) ;
  }

  
  public Node getNode() { return node_; }

  static public class RemoveLabelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIRemoveLabelForm uicomp = (UIRemoveLabelForm) event.getSource();
      String label = uicomp.uiSelect_.getValue();
      Information iprovider = findInformationProvider(uicomp);
      try {
        uicomp.vH_.removeVersionLabel(label);        
        uicomp.setRenderedSibling(UIVersionInfo.class);
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIRemoveLabelForm uicomp = (UIRemoveLabelForm) event.getSource();
      uicomp.setRenderedSibling(UIVersionInfo.class);  
    }
  }  

}
