/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.views.component;

import javax.jcr.Node;

import org.exoplatform.faces.core.component.UIExoComponentBase;
import org.exoplatform.services.cms.views.ManageViewService;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 * @email:   jobdung@yahoo.com
 * @version: $Id: UIViewFormController.java,v 1.0 2006/09/05 09:45:14 dunghoang Exp $
 */

public class UIViewFormController extends UIExoComponentBase {
  protected ManageViewService viewService_;
  protected Node node_;
  public UIViewFormController(ManageViewService viewService) throws Exception {
    viewService_ = viewService;    
    setRendererType("ChildrenRenderer") ;
    addChild(UISelectViewVersionForm.class) ;        
    addChild(UIViewForm.class) ;    
  }
 
  public void showEditViewForm(Node viewNode, boolean isView) throws Exception {    
    UISelectViewVersionForm uiSelect = 
      (UISelectViewVersionForm) getChildComponentOfType(UISelectViewVersionForm.class);
    boolean isVersioned = viewNode.isNodeType("mix:versionable");
    if (isVersioned && !isView) {
      uiSelect.setRendered(true) ; 
      uiSelect.setView(viewNode);  
    }else{
      uiSelect.setRendered(false) ;
    }      
    UIViewForm viewForm = (UIViewForm) getChildComponentOfType(UIViewForm.class);
    viewForm.update(viewNode, isView, null);      
  }

  public void showNewViewForm()
      throws Exception {
    UISelectViewVersionForm uiSelect = 
      (UISelectViewVersionForm) getChildComponentOfType(UISelectViewVersionForm.class);
    uiSelect.setRendered(false) ;
    UIViewForm viewForm = (UIViewForm) getChildComponentOfType(UIViewForm.class);
    viewForm.refresh();          
  }
  
}