/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.cms.transform.impl;

import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

import org.exoplatform.container.component.ComponentPlugin;
import org.exoplatform.services.cms.transform.TransformationService;
import org.exoplatform.services.cms.transform.Transformer;

/**
 * Created by The eXo Platform SAS
 * Author : Pham Xuan Hoa
 *          hoa.pham@exoplatform.com
 * Mar 20, 2007  
 */
public class TransformationServiceImpl implements TransformationService {

  private List<Transformer> transformers_ = new ArrayList<Transformer>(3) ;

  public void addTransformer(ComponentPlugin plugin) throws Exception  {
    if(plugin instanceof Transformer) {
      Transformer t = (Transformer)plugin ;
      transformers_.add(t) ;
    }        
  } 
  
  public boolean transform(InputStream input, String sourceMimeType, OutputStream output, String destinationMime) throws Exception {
    Transformer transformer = null ;
    for(Transformer t:transformers_) {
      if(t.canTransform(sourceMimeType,destinationMime)) {
        transformer = t ;
        break ;
      }              
    }
    if(transformer == null)
      return false ;    
    return transformer.transform(input,sourceMimeType,output,destinationMime) ;            
  }    
}
