package org.exoplatform.services.workflow.impl.oncepi;

import cn.ac.ios.tcse.isflow.WorkList.WorkListServer.ConnectionManager.TaskIdentifier;

/**
 * 
 * @author cwchen
 * This class handles ID difference between Exo and OncePI.
 * Typically:
 * A hash Map mapping TaskIdentifier to taskid;
 * A hash Map mapping tuple<packageid,processid> to processid
 */

public interface IDMapping {
	public TaskIdentifier getTaskIndentifier(String taskid);
	public void  putTaskIndentifier(String taskid,TaskIdentifier ti);
	
	/**
	 * 
	 * @param key The mapped processid
	 * @return String[2] the <packageid,processid> tupe before mapping
	 */
	public String[] getProcessIdTuple(String key);
	/**
	 * 
	 * @param packageid 
	 * @param workflowid
	 * @return The mapped processid
	 */
	public String putProcessIdTuple(String packageid, String workflowid);
}
