/***************************************************************************
 * Copyright 2001-2007 The eXo Platform SAS         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/

import java.util.List;
import java.util.Map;

import javax.jcr.Node;
import javax.jcr.Session;
import javax.jcr.Property;
import javax.jcr.Value;

import org.exoplatform.services.cms.metadata.MetadataService;
import org.exoplatform.services.cms.scripts.CmsScript;
import org.exoplatform.services.jcr.RepositoryService;

/**
 * Created by The eXo Platform SAS
 * Author : Pham Xuan Hoa
 *          hoa.pham@exoplatform.com
 * May 24, 2007  
 */
public class AddMetadataNodeTypesScript implements CmsScript{

  private RepositoryService repositoryService_;  
  private MetadataService metadataService_ ;

  public AddMetadataNodeTypesScript(RepositoryService repositoryService, MetadataService metadataService){
    repositoryService_ = repositoryService;   
    metadataService_ = metadataService;
  }    

public void execute(Object context) {
  Map variables = (Map) context;
  String nodePath = (String)variables.get("nodePath") ;
  String workspace = (String)variables.get("srcWorkspace") ;
  String srcPath = (String)variables.get("srcPath") ;
  String actionName = (String)variables.get("actionName") ;
  Session session = null ;
  try{
    session = repositoryService_.getRepository().getSystemSession(workspace) ;           
    Node srcNode = (Node)session.getItem(srcPath) ;
    Node actionNode = srcNode.getNode(actionName) ;
    List list = metadataService_.getExtenalMetadataType();
    if(!actionNode.hasProperty("exo:metadataNodeTypes")) return ;
    Node addedNode = (Node)session.getItem(nodePath) ;
    Value[] values = actionNode.getProperty("exo:metadataNodeTypes").getValues();      
    int size = values.length ;
    for(i in 0..size-1) {
      String metaName = values[i].getString(); 
      if(list.contains(metaName) && addedNode.canAddMixin(metaName))
        addedNode.addMixin(metaName) ;
    }
    addedNode.save() ;
    session.save() ;
    session.logout() ;                        
  }catch (Exception e) {   
    if(session != null) session.logout() ;
    e.printStackTrace() ;
  }       
}

public void setParams(String[] arg0) {

}

}

