/**
 * Copyright 2001-2006 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 */

package org.exoplatform.services.jcr.ext.audit;

import javax.jcr.Item;
import javax.jcr.RepositoryException;

import org.exoplatform.services.jcr.datamodel.InternalQName;
import org.exoplatform.services.jcr.impl.Constants;


/**
 * Created by The eXo Platform SARL        .
 * @author Gennady Azarenkov
 * @version $Id: $
 */

public interface AuditService {
  public static final String AUDIT_STORAGE_ID = "00exo0jcr0audit0storage0id000000";
  public static final InternalQName EXO_AUDIT = new InternalQName(Constants.NS_EXO_URI, "audit");
  public static final InternalQName EXO_AUDITABLE = new InternalQName(Constants.NS_EXO_URI, "auditable");
  public static final InternalQName EXO_AUDITSTORAGE = new InternalQName(Constants.NS_EXO_URI, "auditStorage");
  public static final InternalQName EXO_AUDITRECORD = new InternalQName(Constants.NS_EXO_URI, "auditRecord");
  public static final InternalQName EXO_AUDITHISTORY = new InternalQName(Constants.NS_EXO_URI, "auditHistory");
  public static final InternalQName EXO_AUDITHISTORY_TARGETNODE = new InternalQName(Constants.NS_EXO_URI, "targetNode");
  public static final InternalQName EXO_AUDITHISTORY_LASTNAME = new InternalQName(Constants.NS_EXO_URI, "lastName");
  
  
  /**
   * creates audit history
   * @param item
   * @throws RepositoryException
   */
  void createHistory(Item item) throws RepositoryException;

  /**
   * deletes audit history
   * @param item
   * @throws RepositoryException
   */
  void removeHistory(Item item) throws RepositoryException;

  /**
   * adds new audit record
   * @param item
   * @param eventType
   * @throws RepositoryException
   */
  void addRecord(Item item, int eventType) throws RepositoryException;
}
