/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: Logger.java 8955 2006-09-18 13:46:06Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.logging;

/**
 * @version $Rev: 8955 $ $Date: 2006-09-18 20:46:06 +0700 (Mon, 18 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public interface Logger {

	Level getCurrentLevel();
	int getCurrentIntLevel();
	void setLevel(Level level);

	void entering(String sourceClass, String sourceMethod);
	void entering(String sourceClass, String sourceMethod, Object param);
	void entering(String sourceClass, String sourceMethod, Object[] params);

	void exiting(String sourceClass, String sourceMethod);
	void exiting(String sourceClass, String sourceMethod, Object result);

	void fine(String msg);
	void finer(String msg);
	void finest(String msg);
	void config(String msg);
	void info(String msg);
	void warning(String msg);
	void severe(String msg);
	void throwing(String sourceClass, String sourceMethod, Throwable thrown);

	boolean isLogging();
}
