/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: RestrictedAction.java 9134 2006-09-26 23:03:22Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applet.security;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FilenameFilter;
import java.security.Provider;

/**
 * @version $Rev: 9134 $ $Date: 2006-09-27 06:03:22 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public interface RestrictedAction {

    // special one: set in boot and gotten in bootable
    String getBaseUrl();
    
    String getUserHome();

    String getProperty(String property);

    FileInputStream getFileInputStream(String fileName);

    FileInputStream getFileInputStream(File file);

    FileOutputStream getFileOutputStream(String fileName);

    FileOutputStream getFileOutputStream(File file);

    // used by filelog...
    FileOutputStream getFileOutputStream(String fileName, boolean append);

//    InputStream getInputStream(URLConnection con);
//
//    InputStream getResourceAsStream(Class clazz, String name);

    boolean mkdirs(File f);

    boolean delete(File f);

    boolean exists(File f);

    boolean isDirectory(File f);

    String[] list(File dir, FilenameFilter filter);

    int addSecurityProvider(Provider prov);

//    boolean load(String lib);
//
//    boolean loadLibrary(String lib);
//
//    Dialog createModalDialog(Frame parent, String title);
//
//    FileDialog getFileDialog(Frame parent, String title, int mode);
//
//    void showFileDialog(FileDialog dialog);
//
//    PrintJob getPrintJob(Frame frame, String title, Properties prefs);
//
//    Thread createThread(Runnable runnable);
//
//    void connect(URLConnection con) throws IOException;
//
//    int getResponseCode(final HttpURLConnection con) throws IOException;

    void setProperty(String name, String value);

//    OutputStream getOutputStream(URLConnection con);
//
//    void addSSLProvider() throws IOException;
//
//    void setDefaultSSLSocketFactory(Object sslSocketFactory);

}
