/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.services.chart;

import java.awt.Color;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;

import org.jfree.util.Rotation;

/**
 * Created by The eXo Platform SARL
 * Author : Hung Nguyen
 *          nqhungvn@users.sourceforge.net
 * Jul 15, 2005
 */

public class Chart implements Serializable {
	public final static int PIE_CHART = 0;
	public final static int COLUMN_CHART = 1;
	
  private String chartTitle_;
  private int chartType_;
  private Color backGroundColor_;
  private int chartWidth_;
  private int chartHeight_;
  private Collection chartData_;
  private boolean is3DChart_;
  //For Pie chart
  private double startAngle_;
  private Rotation direction_;
  private boolean isForeGround_; // {0.5f ; 0 ;...}
  //For Bar chart
  private String categoryLabel_; 
  private String valueLabel_;
  private boolean isHorizontal_;  
  private boolean isDisplayItemLabel_ ;
  
  public Chart(){
    chartData_ = new ArrayList();
    is3DChart_ = false;
    startAngle_ = 0.0;
    backGroundColor_ = Color.white;
    direction_ = Rotation.CLOCKWISE;
    isForeGround_ = false;
    isHorizontal_ = false;
    isDisplayItemLabel_ = false ;
  }
  public void setChartTitle(String title) { this.chartTitle_ = title; }
  public String getChartTitle() { return chartTitle_; }
  
  public void setChartType(int type) { this.chartType_ = type;}
  public int getChartType() { return chartType_; }
  
  public void setBackGroundColor(Color color) { this.backGroundColor_ = color;}
  public Color getBackGroundColor() { return backGroundColor_; }
  
  public void setChartWidth(int width) { this.chartWidth_ = width; }
  public int getChartWidth() { return chartWidth_; }  
  
  public void setChartHeight(int height) { this.chartHeight_ = height; }
  public int getChartHeight() { return chartHeight_; }
  
  public void setChartData(Collection data) { this.chartData_ = data; }
  public Collection getChartData() { return chartData_;}
  
  public void setIs3DChart(boolean type) { this.is3DChart_ = type; }  
  public boolean getIs3DChart() { return this.is3DChart_; }
  // For Pie chart
  public void setStartAngle(double angle) { this.startAngle_ = angle;}  
  public double getStartAngle() { return this.startAngle_; }
  
  public void setDirection(Rotation direction) { this.direction_ = direction; }  
  public Rotation getDirection() { return this.direction_; }
  
  public void setIsForeGround(boolean foreGround) { this.isForeGround_ = foreGround; }  
  public boolean getIsForeGround() { return this.isForeGround_; }
  //For Bar chart
  public void setCategoryLabel(String category) { this.categoryLabel_ = category; }  
  public String getCategoryLabel() { return this.categoryLabel_; }  
  
  public void setValueLabel(String value) { this.valueLabel_ = value; }  
  public String getValueLabel() { return this.valueLabel_; }
  
  public void setIsHorizontal(boolean type) { this.isHorizontal_ = type; }  
  public boolean getIsHorizontal() { return this.isHorizontal_; }
  
  public void setIsDisplayItemLabel(boolean type) { this.isDisplayItemLabel_ = type; }  
  public boolean getIsDisplayItemLabel() { return this.isDisplayItemLabel_; }
}