/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.faces.core.component;

import java.util.List ;
import java.util.ArrayList ;
import java.util.Map ;
import java.io.IOException  ;

import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIListStringInput.java,v 1.3 2004/08/16 14:20:41 tuan08 Exp $
 */
public class UIListStringInput extends UIInput {
  protected List list_ ;

  public UIListStringInput(String name, List list) {
    name_ = name ;
    list_ = new ArrayList(5);
    if (list != null) list_.addAll(list) ;
  }

  final public List getValues() { return list_ ; }

  final public UIListStringInput setValues(List list) { 
    list_.clear() ;
    if (list != null) list_.addAll(list) ;
    return this ;
  }

  public void decode(FacesContext context) {
    Map paramMap = context.getExternalContext().getRequestParameterValuesMap() ;
    String[] values = (String[]) paramMap.get(name_) ;
    if (values != null) {
      list_.clear();
      for (int i =0; i < values.length ; i++) {
        list_.add(values[i]) ;
      }
    }
  }

  public void encodeBegin(FacesContext context) throws IOException {
    ResponseWriter w = context.getResponseWriter() ;
    for (int i =0; i < list_.size(); i++) {
      String value = (String) list_.get(i) ;
      if (value == null) value = "" ;
      w.write("<input name='"); w.write(name_); w.write("'") ; 
      w.write(" value='"); w.write(value); w.write("'") ;
      if (getClazz() != null) {
        w.write(" class='"); w.write(getClazz()); w.write("'") ;
      }
      w.write(" style='margin-top:2px; margin-left:250px'");
      w.write("/><br/>") ;
    }
  }
}