/*
 * Created on Mar 14, 2005
 */
package org.exoplatform.faces.core.component;

import java.util.Iterator;
import java.util.List;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import org.apache.commons.fileupload.FileItem;

/**
 * @author benjaminmestrallet
 */
public class UIUploadInput extends UIInput {

  public enum UIUploadStatus {REMOVED,ADDED,EDIT}

  private String fileName;

  private byte[] content;

  private UIUploadStatus status;

  public UIUploadInput(String name) {
    setId(name);
    name_ = name;
    editable_ = true;
    setRendererType("UploadInputRenderer");
  }

  public byte[] getContent() {
    return content;
  }

  public void setContent(byte[] content) {
    this.content = content; 
    if (hasContent()) {
      setStatus(UIUploadStatus.ADDED);
    }
  }

  public String getFileName() {
    return fileName;
  }

  public void setFileName(String fileName) {
    this.fileName = fileName;
  }

  public void decodeFromMultipartFields(FacesContext context,
      UIComponent component, List items) {
    Iterator iter = items.iterator();
    while (iter.hasNext()) {
      FileItem item = (FileItem) iter.next();
      if (!item.isFormField()) {
        String name = item.getFieldName();
        if (name.equals(getName())) {
          // Some browsers such as IE specify full paths that we have to parse.
          // The java.io.File class cannot be leveraged to do so as the client
          // may use different path separators than the server.
          String[] fileNameItems = item.getName().split("\\\\|/");
          String fileName = fileNameItems[fileNameItems.length - 1];

          byte[] buf = item.get();
          setFileName(fileName);
          setContent(buf);        
        }
      } 
    }
  }

  public boolean hasContent() {
    return !(getContent() == null || getContent().length == 0);
  }

  public UIUploadStatus getStatus() {
    return status;
  }

  public void setStatus(UIUploadStatus status) {
    this.status = status;
  }

  public boolean isRemoved() {
    return status == UIUploadStatus.REMOVED;
  }

  public boolean isAdded() {
    return status == UIUploadStatus.ADDED;
  }

  public boolean isEdited() {
    return status == UIUploadStatus.EDIT;
  }

}