/*
 * Created on Mar 14, 2005
 */
package org.exoplatform.faces.core.component;

import java.io.InputStream;
import java.util.Iterator;
import java.util.List;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import org.apache.commons.fileupload.FileItem;

/**
 * @author benjaminmestrallet
 */
public class UIUploadInputStream extends UIUploadInput {

  private String fileName;

  private InputStream inputStream;

  public UIUploadInputStream(String name) {
    super(name);
  }

  public void setInputStream(InputStream inputStream) {
    this.inputStream = inputStream;
  }
  
  public InputStream getInputStream() {
    return inputStream;
  }
  
  public void decodeFromMultipartFields(FacesContext context,
      UIComponent component, List items) {
    Iterator iter = items.iterator();
    while (iter.hasNext()) {
      FileItem item = (FileItem) iter.next();
      if (!item.isFormField()) {
        String name = item.getFieldName();
        if (name.equals(getName())) {
          // Some browsers such as IE specify full paths that we have to parse.
          // The java.io.File class cannot be leveraged to do so as the client
          // may use different path separators than the server.
          String[] fileNameItems = item.getName().split("\\\\|/");
          String fileName = fileNameItems[fileNameItems.length - 1];
          try {
            InputStream inputStream = item.getInputStream();
            setFileName(fileName);
            setInputStream(inputStream);
          }catch (Exception e) {
            e.printStackTrace();
            // TODO: handle exception
          }
        }
      }
    }
  }
}