package org.exoplatform.faces.core.renderer.html;

import java.io.IOException;
import java.util.Collection;
import java.util.Iterator;
import java.util.ResourceBundle;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.core.component.UIImageUploadInput;

public class ImageUploadInputRenderer extends HtmlBasicRenderer {

	  public void encodeBegin(FacesContext context, UIComponent component)  throws IOException {
	    ResponseWriter w = context.getResponseWriter();
	    UIImageUploadInput uiImageInput = (UIImageUploadInput) component;

	    w.write("<input name='");
	    w.write(uiImageInput.getName());
	    w.write("'");
	    w.write(" type='file'");
	    if (uiImageInput.getClazz() != null) {
	      w.write(" class='");
	      w.write(uiImageInput.getClazz());
	      w.write("'");
	    }
	    if (!uiImageInput.isEditable() || uiImageInput.isReadonly()) {
	      w.write(" readonly='readonly' ");
	    }
	    w.write("/>");
      
      ResourceBundle res = getApplicationResourceBundle(context.getExternalContext());
       
      //remove flag
      w.write("<label>" + res.getString("global.word.delete") + "</label>");
      w.write("<input type='checkbox' name='remove-" + uiImageInput.getName() + "'/>");
      
	    // image preview
      PortalContainer container = PortalContainer.getInstance();
      String pName = container.getContext().getName();
      /*
      getBaseURL()
      <img src="/${uicomponent.getPortalName()}/jcr?workspace=${uicomponent.getWorkspaceName()}&path=${node.getPath()}&relativePath=exo:foto-principale" width="80" height="80"/>

      w.write("<img src='/" + pName + "/jcr?workspace'");
      w.write("");
      w.write("/>");
      */
	    if(uiImageInput.hasSelectors()){
	      Collection selectors = uiImageInput.getSelectors();
	      for (Iterator iter = selectors.iterator(); iter.hasNext();) {
	        String button = (String) iter.next();
	        w.write(button);
	      }
	    }    
	    if (uiImageInput.hasError()) {
	      w.write("<span style='color: red'>*</span>");
	    }
	  }   
}
