package org.exoplatform.velocity.directive;

import java.io.IOException;
import java.io.Writer;
import java.util.List;
import javax.faces.context.FacesContext;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
import org.exoplatform.faces.core.component.UIExoComponent ;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class JSFRenderChildren extends Directive {
  public String getName()  {    return "jsfRenderChildren"; }        
  
  public int getType() {  return LINE; }        

  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
      super.init(rs, context, node);
  }

  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {        
    UIExoComponent component = (UIExoComponent)context.get(UIExoComponent.UICOMPONENT) ;
    List children = component.getChildren() ;
    for(int i = 0; i < children.size(); i++) {
      UIExoComponent child = (UIExoComponent)children.get(i) ;
      FacesContext facescontext = FacesContext.getCurrentInstance() ;
      child.encodeBegin(facescontext) ;
      child.encodeChildren(facescontext) ;
      child.encodeEnd(facescontext) ;
    }
    return true;
  }
}
