package org.exoplatform.velocity.directive;

import java.util.MissingResourceException;
import java.util.ResourceBundle ;
import java.io.IOException;
import java.io.Writer;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.exception.MethodInvocationException;
import org.apache.velocity.exception.ParseErrorException;
import org.apache.velocity.exception.ResourceNotFoundException;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;
import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.model.Parameter;
/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since March 3, 2005
 * @version $Id$
 */
public class JSFResLink extends Directive {
  public String getName()  {    return "jsfResLink"; }        
  
  public int getType() {  return LINE; }        
  
  public void init(RuntimeServices rs, InternalContextAdapter context, Node node) throws Exception {
    super.init(rs, context, node);
  }
  
  public boolean render(InternalContextAdapter context,  Writer w, Node node)
  throws IOException,  MethodInvocationException, ResourceNotFoundException, ParseErrorException {
    ResourceBundle res = (ResourceBundle)context.get("res") ;
    String  label = (String)node.jjtGetChild(0).value(context);
    try {
      label = res.getString(label) ;
    } catch (MissingResourceException ex) { }
    
    Parameter[] params = (Parameter[])node.jjtGetChild(1).value(context);
    UIExoComponent component = (UIExoComponent)context.get(UIExoComponent.UICOMPONENT) ;
    w.write("<a  href='");
    w.write(component.getBaseURL());
    for (int i = 0; i < params.length; i++) {
      w.write("&amp;");
      w.write(params[i].getName());
      w.write('=');
      w.write(params[i].getValue());
    }
    if(node.jjtGetNumChildren() > 2) {
      String  beanid = node.jjtGetChild(2).value(context).toString();
      w.write("&amp;" + UIExoComponent.OBJECTID + "="); w.write(beanid);
    }
    w.write("'>");
    w.write(label);
    w.write("</a>");
    return true;
  }
}