/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.config.impl;

import org.exoplatform.portal.config.model.Page;
import org.exoplatform.portal.config.model.Permission;

/**
 * Created by The eXo Platform SARL        .
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Date: Jun 14, 2003
 * Time: 1:12:22 PM
 *
 * @hibernate.class  table="EXO_PAGE"
 *                   polymorphism="explicit"
 */
public class PageData extends PageDescriptionData {

  transient private Page page_ ;  

  public PageData() { }

  public PageData(Page page) throws Exception { 
  	setPage(page) ;
  }

  public PageData(String xml) throws Exception { 
    setData(xml) ; 
  }

  /**
   * @hibernate.property length="65535" type="org.exoplatform.services.database.impl.TextClobType"
   **/
  public String getData() throws Exception {
    String xml =  PortalConfigServiceImpl.toXML(page_) ;
    return xml ;
  }

  public void  setData(String s) throws Exception {
    page_ = (Page)PortalConfigServiceImpl.fromXML(s, Page.class) ;
    owner_ = page_.getOwner() ;
    name_ = page_.getName() ;
    title_ = page_.getTitle() ;
    id_ = getId(page_);
    Permission perm = page_.getViewPermission() ;
    if(perm != null) viewPermission_ =  perm.toString() ;
    perm = page_.getEditPermission() ;
    if(perm != null) editPermission_ =  perm.toString() ;
  }
  
  public Page getPage() { return page_ ; }
  public void    setPage(Page obj) { 
    page_ = obj ; 
    owner_ = page_.getOwner() ;
    name_ = page_.getName() ;
    title_ = page_.getTitle() ;
    id_ = page_.getPageId() ;
    Permission perm = page_.getViewPermission() ;
    if(perm != null){
      viewPermission_ =  perm.toString() ;
    }else{
      editPermission_ =  null;
    }
    perm = page_.getEditPermission() ;
    if(perm != null){
      editPermission_ =  perm.toString() ;
    }else{
      editPermission_ =  null;
    }
  }
  
  static public String getId(Page page) {
    return page.getOwner() + ":" + page.getName() ;
  }
}