/***************************************************************************
 * Copyright 2001-2003 The VietSpider Studio        All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portal.config.impl.converter.v11tov2;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.exoplatform.portal.config.model.PortletPreferences;
import org.exoplatform.portal.config.model.Preference;
import org.exoplatform.xml.object.XMLEntry;
import org.exoplatform.xml.object.XMLMap;
import org.exoplatform.xml.object.XMLObject;

/**
 * Created by VietSpider Studio
 * Author : Nhu Dinh Thuan
 *          nhudinhthuan@yahoo.com
 * Dec 15, 2005
 */
public class PreferencesConverter extends ObjectConverter {  
  
  public void update(  XMLObject xml, String name, Object o, Object n)throws Exception{   
    String[] p = this.toArray( o);    
    String[] v = this.toArray( n);   
    
    PortletPreferences  pre = new PortletPreferences (); 
    ArrayList<Preference> list = new ArrayList<Preference>();   
    XMLMap map = xml.getField("portletPreferences").getMap();
    if( map != null) {  
      Iterator i = map.getEntryIterator();    
      while( i.hasNext()){
        XMLEntry entry = (XMLEntry)i.next();          
        XMLObject obj = entry.getValue().getObject();  
        list.add( convertPreference(obj, p, v));
      }    
    }
    if( v != null && list.size() == 0) {
      list.add( convertPreference( null, null, v));
    }
    pre.setPreferences( list);
    xml.removeField( name);
    xml.addField( name, pre.getClass(), pre) ;   
  }
  
  private String[] toArray( Object obj){
    if( obj == null) return new String[]{};
    List list  = (ArrayList) obj;
    String[] arr = new String[ list.size()];
    for( int i=0; i< arr.length; i++) arr[i] = (String)list.get(i);
    return arr;
  }
  
  protected Preference convertPreference( XMLObject xml, String[] p, String[] v)throws Exception {   
    Preference  pre = new Preference();
    ArrayList<String> list = null;
    if( xml != null){
      list  = (ArrayList)xml.getFieldValue("values");     
      pre.setName( (String)xml.getFieldValue("name"));
      pre.setReadOnly( (Boolean)xml.getFieldValue("readOnly"));
      if( v == null){
        pre.setValues( list);
        return pre;
      }
    }else{
      pre.setReadOnly( true);
      pre.setName("template");
    }
    if( list  == null) list  = new ArrayList<String>();
    if( p != null){
      for( int i = 0; i< p.length; i++){        
        if( p[i] != null ){
          for( int j= 0; j<list.size(); j++)
            if( list.get( j).toString().indexOf( p[i])> -1 ) {
              if ( v[i] != null )list.set( j, v[i]);              
              else list.remove( j);  
            }
        }else if( v[i] != null)  list.add( v[i]);    
      }
    }else if( v !=  null)
      for( int i = 0; i< v.length; i++)
        if ( v[i] != null)  list.add( v[i]);    
      
    pre.setValues( list);    
    return pre;
  } 
}
