/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.user.component;

import java.util.List;

import javax.faces.context.FacesContext;

import org.exoplatform.faces.core.component.UIExoComponent;
import org.exoplatform.faces.core.component.UINode;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.component.UITextArea;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portlets.user.component.UIOrganizationPortlet.UIGroupNode;
import org.exoplatform.portlets.user.component.UIOrganizationPortlet.UIMembershipNode;
import org.exoplatform.services.organization.MembershipType;
import org.exoplatform.services.organization.OrganizationService;
/**
 * Sat, Jan 03, 2004 @ 11:16 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIMembershipTypeForm.java,v 1.10 2004/09/21 00:16:12 tuan08 Exp $
 */
public class UIMembershipTypeForm extends UISimpleForm {
  private MembershipType membershipType_ ;
  private OrganizationService service_ ;
  private static String MEMBERSHIP_NAME = "membershipName", 
                        DESCRIPTION = "description" ;
  public UIMembershipTypeForm(OrganizationService service) throws Exception {
    super("membershipTypeForm", "post", null) ;
    service_ = service ;
    setRendererType("SimpleFormVelocityRenderer") ;
    add(new UIStringInput(MEMBERSHIP_NAME, "")) ;
    add(new UITextArea(DESCRIPTION, "")) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
  }
  
  public void setMembershipType(String name) throws Exception {
    membershipType_ = service_.getMembershipTypeHandler().findMembershipType(name) ;
    getUIStringInput(MEMBERSHIP_NAME).setValue(name) ;
    getUIStringInput(MEMBERSHIP_NAME).setEditable(false) ;
    getUIStringInput(DESCRIPTION).setValue(membershipType_.getDescription()) ;
  }

  public void addMembershipType()  {
    membershipType_ = null ;
    getUIStringInput(MEMBERSHIP_NAME).setValue("") ;
    getUIStringInput(MEMBERSHIP_NAME).setEditable(true) ;
    getUIStringInput(DESCRIPTION).setValue("") ;
  }
  
  static public class SaveActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMembershipTypeForm uiForm = (UIMembershipTypeForm) event.getSource() ;
      String user = FacesContext.getCurrentInstance().getExternalContext().getRemoteUser();
      if(user == null ) user = "" ;
      if (uiForm.membershipType_ == null) {
         uiForm.membershipType_ = uiForm.service_.getMembershipTypeHandler().createMembershipTypeInstance() ;
         uiForm.membershipType_.setName(uiForm.getUIStringInput(MEMBERSHIP_NAME).getValue()) ;
         uiForm.membershipType_.setDescription(uiForm.getUIStringInput(DESCRIPTION).getValue()) ;
         uiForm.membershipType_.setOwner(user) ;
         uiForm.service_.getMembershipTypeHandler().createMembershipType(uiForm.membershipType_, true) ;
         
         UIOrganizationPortlet uiPortlet = (UIOrganizationPortlet)uiForm.getAncestorOfType(UIOrganizationPortlet.class);
         uiPortlet.refresh();        
       } else {
         uiForm.membershipType_.setDescription(uiForm.getUIStringInput(DESCRIPTION).getValue()) ;
         uiForm.service_.getMembershipTypeHandler().saveMembershipType(uiForm.membershipType_,  true) ;
       }
       UIMembershipNode uiController = (UIMembershipNode) uiForm.getParent() ;
       UIListMembershipType uiList = 
         (UIListMembershipType)uiController.getChildComponentOfType(UIListMembershipType.class) ;
       uiList.update() ;
       uiController.setRenderedComponent(uiList.getId()) ;
    }
  }
  
  static public class CancelActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UIMembershipTypeForm uiForm = (UIMembershipTypeForm) event.getSource() ;
      UIMembershipNode uiController = (UIMembershipNode) uiForm.getParent() ;
      uiController.setRenderedComponent(UIListMembershipType.class) ;
    }
  }
}
