/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.portal.component;

import java.util.*;
import javax.faces.context.FacesContext;
import javax.portlet.PortletPreferences;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.application.ExoFacesMessage;
import org.exoplatform.faces.context.PortletExternalContext;
import org.exoplatform.faces.core.component.*;
import org.exoplatform.faces.core.component.model.SelectItem;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;

/**
 * @author Tuan Nguyen (tuan08@users.sourceforge.net)
 * @since Aug 27, 2004
 * @version $Id: UISearchBar.java,v 1.2 2004/10/30 02:29:51 tuan08 Exp $
 */
public class UITemplateSelector extends UISimpleForm {
  public UITemplateSelector() throws Exception {
    super("templateSelectorForm", "post", null) ;
  	setId("UITemplateSelector") ;
    setRendererType("SimpleFormGroovyRenderer") ;
    List<SelectItem> templates = new ArrayList<SelectItem>() ;
    PortletExternalContext context = 
      (PortletExternalContext)FacesContext.getCurrentInstance().getExternalContext() ;
    String[] tnames = context.getConfig().getInitParameter("available.templates").split(",") ;
    ResourceBundle res = context.getApplicationResourceBundle() ;
    PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
    String currentTemplate = prefs.getValue("template", "") ;
    for(String tname : tnames){    
      tname =  tname.trim() ;
      String tmpl    = res.getString("UITemplateSelector.template." + tname) ;
      String label = res.getString("UITemplateSelector.template." + tname + ".label") ;
      templates.add(new SelectItem(label, tmpl)) ;          
    }
    UIRadioBox uiRadioBox = new UIRadioBox("template", currentTemplate, templates);
    add(uiRadioBox.setAlign(UIRadioBox.VERTICAL_ALIGN)) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
    
  static public class SaveActionListener extends ExoActionListener  {
    public void execute(ExoActionEvent event) throws Exception {
      UITemplateSelector uiForm = (UITemplateSelector) event.getSource() ;
      PortletPreferences prefs = FacesUtil.getPortletPreferences() ;
      Information iprovider = findInformationProvider(uiForm);
      try{
        prefs.setValue("template", uiForm.getUIRadioBox("template").getValue()) ;      
        prefs.store() ;
      }catch(Exception exp){
        iprovider.addMessage(new ExoFacesMessage(exp.getMessage()));
      }
    }
  }
}