package org.esupportail.cas.server.handlers.database;

import org.dom4j.Element;
import org.esupportail.cas.server.util.RedundantHandler;

/**
 * This abstract class implements a database handler class, inherited by
 * BindDatabaseHandler and SearchDatabaseHandler.
 *
 * @author Pascal Aubry <pascal.aubry at univ-rennes1.fr>
 */
abstract class DatabaseHandler extends RedundantHandler {
	
	/**
	 * Constructor.
	 *
	 * @param handlerElement the XML element that declares the handler 
	 * in the configuration file
	 * @param configDebug debugging mode of the global configuration
	 * @throws Exception Exception
	 */
	protected DatabaseHandler(
			final Element handlerElement, 
			final Boolean configDebug) throws Exception {
		super(handlerElement, configDebug);
		traceBegin();

		// check that a config element is present
		checkConfigElement(true);

		traceEnd();
	}

}
