/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.report;

import groovy.lang.GroovyClassLoader;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.net.URL;

import org.exoplatform.test.web.GroovyResourceManager;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class HTMLReportGroovyResourceManager extends GroovyResourceManager {
  private String groovyPath_ ;
  
  public HTMLReportGroovyResourceManager(GroovyClassLoader classloader, String groovyPath) {
    super(classloader) ;
    groovyPath_ =  groovyPath ;
    setCacheTemplate(true) ;
  }
  
  protected InputStream getResourceAsStream(String name) throws Exception {
    File file = new File(groovyPath_ +  "/" + name) ;
    if(file.exists()) return  new FileInputStream(file);
    ClassLoader cl = Thread.currentThread().getContextClassLoader() ;
    return cl.getResourceAsStream(name) ;
  }
  
  protected URL getResource(String name) throws Exception {
    File file = new File(groovyPath_ +  "/" + name) ;
    if(file.exists()) return  file.toURL() ;
    ClassLoader cl = Thread.currentThread().getContextClassLoader() ;
    return cl.getResource(name) ;
  }
  
  protected void addGroovyPath(GroovyClassLoader cl) throws Exception {
    cl.addClasspath(groovyPath_) ;
  }
}