/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.test.web.servlet;

import groovy.lang.GroovyClassLoader;

import java.io.InputStream;
import java.net.URL;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;

import org.exoplatform.test.web.GroovyResourceManager;
/**
 * Created by The eXo Platform SARL
 * Author : Tuan Nguyen
 *          tuan08@users.sourceforge.net
 * Dec 21, 2005
 */
public class WebappGroovyResourceManager extends GroovyResourceManager {
  private ServletContext scontext_ ;
  
  public WebappGroovyResourceManager(GroovyClassLoader classloader, ServletContext context) {
    super(classloader) ;
    scontext_ = context ;
  }
  
  protected InputStream getResourceAsStream(String name) throws Exception {
    return scontext_.getResourceAsStream("/groovy/" + name) ;
  }
  
  protected URL getResource(String name) throws Exception {
    return scontext_.getResource("/groovy/" + name) ;
  }
  
  protected void addGroovyPath(GroovyClassLoader cl) throws Exception {
    cl.addClasspath(scontext_.getRealPath("/groovy")) ;
    cl.addClasspath(scontext_.getRealPath("/WEB-INF/classes")) ;
  }
  
  public Map<String, Object>  createDefaultBinding(HttpServletRequest request) {
    Map<String, Object> binding = new HashMap<String , Object>();
    binding.put("session", request.getSession()) ;
    binding.put("templates" , this) ;
    return binding ;
  }
}