/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.categorybrowser;

import condition.* ;
import suites.portal.*;
import suites.share.NewAccountSuite;
import suites.share.UserLoginSuite;
import suites.ecm.user.UserAddFolderSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;

/**
 * Created by The eXo Platform SARL
 * Author : HoaPham
 *          phamvuxuanhoa@yahoo.com
 * Feb 8, 2006
 */

static public class UserPrepareDataSuite extends WebUnitSuite{
  static String DESC = "Go to ECM File Explorer page to create some data" ;
  static String NAME = "UserPrepareDataSuite" ;
  
  public UserPrepareDataSuite(){       
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());
    //==================================CREATE SOME NT:FILE  AND REFERENCE TO CB===============
    for ( i in [1,2,3]){
      addWebUnit(
          new ClickURLLinkUnit("AddDocument", "click on Add Document button").
          setURL("&uicomponent=UIToolbar&op=addDocument").                  
          addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
          addValidator(new ExpectFormIdValidator("contentForm"))
      ) ;
      
      addWebUnit(        
          new SubmitFormUnit("SelectDocumentType'nt:file'", "select document type is nt:file").
          setFormId("selectContentTypeForm").   
          setField("contentType","nt:file").
          setField("op","changeType").          
          addValidator(new ExpectTextValidator("File")).
          addValidator(new ExpectTextValidator("Content:"))
      ) ;    
      
      addWebUnit(
          new SubmitFormUnit("SaveNewFile${i}", "click on save button").
          setFormId("contentForm").   
          setField("contentName","fileName${i}").
          setField("summary","file content${i}").      
          setField("op","save").
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=editDocument&objectId=fileName${i}"))
        ) ;      
      // add a reference to this file
      addWebUnit(
          new ClickURLLinkUnit("SelectThisFile", "click on file to view").
          setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/cms/home/users/#{client.name}/test-folder/fileName${i}").
          addValidator(new ExpectTextValidator("file content${i}"))      
      ) ; 
      //goto admintab
      addWebUnit(
          new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
          setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIAdminAction").             
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
        ) ;
      //-----Manage Category
      addWebUnit(
        new ClickURLLinkUnit("ClickOnManageCategory", "click on Manage Category button").
        setURL("&uicomponent=UIToolbar&op=manageCategories").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))      
      ) ;   
      //----------Add Category
      addWebUnit(
        new ClickURLLinkUnit("AddCategory", "click on Add Category button").
        setURL("&uicomponent=UICategoriesList&op=add").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms"))      
      ) ;                   

      if(i<3) {
        //---add referce to "new"
        addWebUnit(
          new ClickURLLinkUnit("SelectNode", "click select button on node row").
          setURL("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/news").      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/news"))      
        ) ;             
      }
      else {
        //---add referce to "sports"
        addWebUnit(
          new ClickURLLinkUnit("SelectNode", "click select button on node row").
          setURL("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/sports").      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/sports"))      
        ) ;
      }
      //---back to test-folder
      addWebUnit(
          new ClickURLLinkUnit("BackToTestFolder", "back to 'TestFolder' node").
          setURL("uicomponent=UIJCRExplorer&op=changeNode&objectId=/cms/home/users/#{client.name}/test-folder")      
        ) ;      
      addWebUnit(
          new ClickURLLinkUnit("GoToActionTab", "go to Action Tab").
          setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction")      
        ) ;
      // Save session
      addWebUnit(
          new ClickURLLinkUnit("SavedSession", "click on save Session button").
          setURL("&uicomponent=MainToolbar&op=saveSession").        
          addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;      
    }                
    //==================================ADD SOME EXO:ARTICLE AND REFERENCE TO CB===============
    //---back to user node
    addWebUnit(
        new ClickURLLinkUnit("BackToUserNode", "back to '#{client.name}' node").
        setURL("uicomponent=UIJCRExplorer&op=changeNode&objectId=/cms/home/users/#{client.name}")      
      ) ;
    addWebUnit(
        new ClickURLLinkUnit("GoTo 'Site' Node", "go to Site/En Node to create article").
        setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/cms/home/users/#{client.name}/site")      
      ) ;
    
    addWebUnit(
        new ClickURLLinkUnit("GoTo 'Site' Node", "go to Site/En Node to create article").
        setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/cms/home/users/#{client.name}/site/en")      
      ) ;
    addWebUnit(
        new ClickURLLinkUnit("GoToActionTab", "go to Action Tab").
        setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction")      
      ) ;

    for(i in [1,2,3]) {
      addWebUnit(
          new ClickURLLinkUnit("AddDocument", "click on Add Document button").
          setURL("&uicomponent=UIToolbar&op=addDocument").                  
          addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
          addValidator(new ExpectFormIdValidator("contentForm"))
      ) ;
      
      addWebUnit(        
          new SubmitFormUnit("SelectType'exo:article'", "select document type is exo:article").
          setFormId("selectContentTypeForm").   
          setField("contentType","exo:article").
          setField("op","changeType").          
          addValidator(new ExpectTextValidator("Article")).
          addValidator(new ExpectTextValidator("Title:"))
      ) ;
      
      addWebUnit(
          new SubmitFormUnit("SaveArticle${i}", "click on save button").
          setFormId("contentForm").   
          setField("contentName","articleName${i}").
          setField("title","articleTitle${i}").
          setField("summary","articleSummary${i}").
          setField("content","articleContent${i}").
          setField("op","save").
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeNode&objectId=/cms/home/users/#{client.name}/site/en/articleName${i}"))
        ) ;
      //add a reference to this article
      addWebUnit(
          new ClickURLLinkUnit("ViewThisArticle", "click on article to view").
          setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/cms/home/users/#{client.name}/site/en/articleName${i}").
          addValidator(new ExpectTextValidator("articleTitle${i}")).
          addValidator(new ExpectTextValidator("articleSummary${i}")).
          addValidator(new ExpectTextValidator("articleContent${i}"))      
      ) ; 
      //goto admintab
      addWebUnit(
          new ClickURLLinkUnit("SelectAdminTab", "click on Admin tab").
          setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIAdminAction").             
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageVersions")).      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageCategories")).
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=manageActions")).      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=exportNode")).
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=importNode"))
        ) ;
      //-----Manage Category
      addWebUnit(
        new ClickURLLinkUnit("ClickOnManageCategory", "click on Manage Category button").
        setURL("&uicomponent=UIToolbar&op=manageCategories").                  
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=add"))      
      ) ;   
      //----------Add Category
      addWebUnit(
        new ClickURLLinkUnit("AddCategory", "click on Add Category button").
        setURL("&uicomponent=UICategoriesList&op=add").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms"))      
      ) ;          
      if(i<3) {
        //---add referce to "sports"
        addWebUnit(
          new ClickURLLinkUnit("SelectNode", "click select button on node row").
          setURL("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/sports").      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/sports"))      
        ) ;
      }
      else {
        //---add referce to "new"
        addWebUnit(
          new ClickURLLinkUnit("SelectNode", "click select button on node row").
          setURL("&uicomponent=JcrBrowser&op=selectNode&objectId=/cms/categories/cms/news").      
          addValidator(new ExpectLinkWithURLValidator("&uicomponent=UICategoriesList&op=delete&objectId=/cms/categories/cms/news"))      
        ) ;
      }
      
      //---back to site/en node
      addWebUnit(
          new ClickURLLinkUnit("GoTo 'Site' Node", "go to Site/En Node to create article").
          setURL("&uicomponent=UIJCRExplorer&op=changeNode&objectId=/cms/home/users/#{client.name}/site/en")      
        ) ;      
      addWebUnit(
          new ClickURLLinkUnit("GoToActionTab", "go to Action Tab").
          setURL("&uicomponent=UIViewController&op=selectNode&objectId=UIDefaultAction")      
        ) ;                  
      //  Save session
      addWebUnit(
          new ClickURLLinkUnit("SavedSession", "click on save Session button").
          setURL("&uicomponent=MainToolbar&op=saveSession").        
          addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;             
    }
    
  }  
  public java.util.List getRequiredSuites(){
    String[] roles = ["user"] ;
    return [new NewAccountSuite(),
              new UserLoginSuite("#{client.name}","#{client.name}",roles)];
  }
}