/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.temp;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.share.UserLogoutSuite;

/**
 * Need to check that the changes to the rule have been taken into accoount 
 *
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class AdminAddMultiDraftNodeTypesSuite extends WebUnitSuite {
  static String DESC = "Go to Admin The ECM page, click on Manage Node Type button and add 70 nodetypes" ;
  static String NAME = "AdminAddMultiDraftNodeTypesSuite" ;
    
  public AdminAddMultiDraftNodeTypesSuite() {    
    super(NAME, DESC) ;   
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTheECM", "Select Admin The ECM tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=ecm").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageTemplates"))      
    ) ;
    addWebUnit(
      new ClickURLLinkUnit("Add/EditNodeType", "Click on Add/Edit Node Type button").
      setURL("&uicomponent=UIECMAdminSummary&op=addEditNodeType").       
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UINodeTypeList&op=add"))      
    ) ;          
    for ( i in 1..63){
      //-----Save node type    
      addWebUnit(
        new ClickURLLinkUnit("CreateNodeType", "Click on add button").
        setURL("&uicomponent=UINodeTypeList&op=add").                  
        addValidator(new ExpectFormIdValidator("uiNodeTypeForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SaveDraftNodeType", "Click on save draft button").
        setFormId("uiNodeTypeForm").         
        setField("namespace","exo").
        setField("nodeTypeName","test"+i).      
        setField("mixinType","true").
        setField("hasOrderableChildNodes","false").
        setField("superTypes","nt:base").
        setField("op","saveDraft")         
      ) ;       
    }    
  }     
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}