/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.temp;

import condition.* ;
import suites.share.CommonUnit ;
import suites.share.UserLoginSuite;

import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.share.UserLogoutSuite;

/**
 * Need to check that the changes to the rule have been taken into accoount 
 *
 *
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class AdminMultiNamespacesSuite extends WebUnitSuite {
  static String DESC = "Go to Admin The ECM page, click on Manage Name Space button and test all the basic actions" ;
  static String NAME = "AdminMultiNamespacesSuite" ;
    
  public AdminMultiNamespacesSuite() {    
    super(NAME, DESC) ;   
    goToPage("/Home/ecm") ;
    addWebUnit(
      new ClickURLLinkUnit("SelectAdminTheECM", "Select Admin The ECM tab").
      setURL("componentId=ECMPage&portal:action=changeTab&objectId=ecm").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageTemplates"))      
    ) ;      
    //Manage NameSpaces
    addWebUnit(
      new ClickURLLinkUnit("NameSpace", "Click on Name Space button").
      setURL("&uicomponent=UIECMAdminSummary&op=registerNamespace").       
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UINamespaceRegistry&op=add"))         
    ) ;    
    for (i in 1..63){
      //-----Add Name Space
      addWebUnit(
        new ClickURLLinkUnit("AddNameSpace", "Click on Add button").
        setURL("&uicomponent=UINamespaceRegistry&op=add").        
        addValidator(new ExpectFormIdValidator("namespaceRegistryForm"))      
      ) ;        
      //-----Save Name Space
      addWebUnit(
        new SubmitFormUnit("SaveNewNameSpace", "Click on save link").
        setFormId("namespaceRegistryForm").
        setField("prefix","prefix"+i).                  
        setField("uri","uri"+i).
        setField("op","save")                
      ) ;
    }
    //-----Go back to Admin the ECM
    addWebUnit(
      new ClickURLLinkUnit("BackToAdmintheECM", "Click on back button").
      setURL("uicomponent=UIRuleList&op=back"). 
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIECMAdminSummary&op=manageScripts"))         
    ) ;
  }     
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user", "admin"] ;
    return [new UserLoginSuite(CommonUnit.NAME_EXO_ADMIN, "exo", roles)] ;
  }  
}