/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
import suites.runner.ECMUserSuites;

/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * 01 16, 2007
 */
public class UserMultiLanguageSuite extends WebUnitSuite {
  static String DESC = "Go to test-folder, create a exo:article node, then test multilanguage" +
      " with this node" ;
  static String NAME = "UserMultiLanguageSuite" ;
  String COMMENT  = "You must run AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserMultiLanguageSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());       
    addWebUnit(
      new ClickURLLinkUnit("SelectActiontab", "Select Actions tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Actions").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=addDocument"))      
    ) ;    
    //Add document
    addWebUnit(
      new ClickURLLinkUnit("AddDocument", "click on Add Document button").
      setURL("uicomponent=UIToolbar&op=addDocument").    
      addValidator(new ExpectFormIdValidator("selectContentTypeForm")).
      addValidator(new ExpectFormIdValidator("contentForm"))
    ) ;    
    addWebUnit(
      new SubmitFormUnit("SelectArticle", "select document type is Article").
      setFormId("selectContentTypeForm").   
      setField("contentType","exo:article").
      setField("op","changeType").
      addValidator(new ExpectTextValidator("Summary"))
    ) ;           
    //----------Save New Document
    addWebUnit(
      new SubmitFormUnit("SaveNewDocument", "click on save button").
      setFormId("contentForm").   
      setField("contentName","test-doc").
      setField("title","english-title").      
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("uicomponent=UIContentManager&op=editDocument&objectId=/home/users/#{client.name}/test-folder/test-doc"))                                                   
    ) ;  
    if (UserECMFileExplorerSuite.isEnableJCR) {
      //Click on preferences icon
      addWebUnit(
        new ClickURLLinkUnit("ClickOnPreferences", "click on preferences icon").
        setURL("uicomponent=MainToolbar&op=preferences").                  
        addValidator(new ExpectFormIdValidator("preferencesForm"))      
      ) ; 
      addWebUnit(
        new SubmitFormUnit("SelectEnableJCRLikeStructure", "Select Enable JCR like structure and save").
        setFormId("preferencesForm").
        setCheckBox("checkbox",true).
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=MainToolbar&op=saveSession"))
      ) ;
      //Save session
      addWebUnit(
        new ClickURLLinkUnit("SavedSession", "click on save Session button").
        setURL("&uicomponent=MainToolbar&op=saveSession").        
        addValidator(new ExpectTextValidator("All the changes have been saved"))      
      ) ;
    }        
    //Add Language 
    addWebUnit(
      new ClickURLLinkUnit("ClickOnTest-doc", "click on test-doc").
      setURL("&uicomponent=UIContentManager&op=changeNode&objectId=/home/users/#{client.name}/test-folder/test-doc").        
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=removeNode&objectId=/home/users/#{client.name}/test-folder/test-doc", 0))      
    ) ;
    addWebUnit(
      new SubmitFormUnit("SelectSimpleView", "Select simple view and click om apply link").
      setFormId("UISelectViewForm").
      setField("views","simple-view").                  
      setField("op","save").      
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIViewController&op=selectNode&objectId=Collaboration"))      
    ) ; 
    addWebUnit(
      new ClickURLLinkUnit("SelectCollaborationTab", "Select Collaboration tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Collaboration").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=multiLanguage"))      
    ) ;    
    addWebUnit(
      new ClickURLLinkUnit("Add/EditLocaliesContents", "Click on Add/edit localies contents").
      setURL("&uicomponent=UIToolbar&op=multiLanguage").                  
      addValidator(new ExpectFormIdValidator("uiMultiLanguageForm"))      
    ) ;
    //-----Add language
    addWebUnit(
      new SubmitFormUnit("ClickOnAddLanguage", "click on add language icon").
      setFormId("uiMultiLanguageForm").      
      setField("op","addLanguage").
      addValidator(new ExpectFormIdValidator("uiAddLanguageForm"))
    ) ;    
    if (!UserECMFileExplorerSuite.isEnableJCR) {
      addWebUnit(
        new SubmitFormUnit("SaveLocalisedContents", "click on save button").
        setFormId("uiAddLanguageForm").  
        setField("language","Vietnamese").
        setField("title","vietnamese-title").      
        setField("op","save").
        addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIContentManager&op=changeLanguage&objectId=vi"))
      ) ;
    }else{
      addWebUnit(
        new SubmitFormUnit("SaveLocalisedContents", "click on save button").
        setFormId("uiAddLanguageForm").  
        setField("language","Vietnamese").
        setField("title","vietnamese-title").      
        setField("op","save")               
      ) ;      
    }
    //Set Default    
    addWebUnit(
      new ClickURLLinkUnit("Add/EditLocaliesContents", "Click on Add/edit localies contents").
      setURL("&uicomponent=UIToolbar&op=multiLanguage").                  
      addValidator(new ExpectFormIdValidator("uiMultiLanguageForm"))      
    ) ;   
    if (!UserECMFileExplorerSuite.isEnableJCR) {
      addWebUnit(
        new SubmitFormUnit("ClickSetDefault", "click on set default link").
        setFormId("uiMultiLanguageForm").    
        setField("language","Vietnamese").
        setField("op","save").
        addValidator(new ExpectTextValidator("vietnamese-title"))
      ) ;
    }else{
      addWebUnit(
        new SubmitFormUnit("ClickSetDefault", "click on set default link").
        setFormId("uiMultiLanguageForm").    
        setField("language","Vietnamese").
        setField("op","save")        
      ) ;          
    }
    //Return to Drive selection
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ; 
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}