/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package suites.ecm.user;

import condition.* ;
import suites.share.* ;
import org.exoplatform.test.web.*;
import org.exoplatform.test.web.unit.*;
import org.exoplatform.test.web.validator.*;
/**
 * Created by The eXo Platform SARL
 * Author : Dung Hoang
 *          dunghoang@exoplatform.com, jobdung@yahoo.com
 * Dec 27, 2005
 */
public class UserViewNodePropertiesSuite extends WebUnitSuite {
  static String DESC = "Go to View Node Properties page and test all the basic actions" ;
  static String NAME = "UserViewNodePropertiesSuite" ;  
  String COMMENT  = "You must run AdminManageTaxonomySuite, AdminViewSuite and AdminDriveSuite before run this suite";
  
  public UserViewNodePropertiesSuite() {    
    super(NAME, DESC) ;
    addWebSuite(new UserAddFolderSuite());    
    //-----Select Info tab
    addWebUnit(
      new ClickURLLinkUnit("SelectInfoTab", "click on info tab").
      setURL("&uicomponent=UIViewController&op=selectNode&objectId=Info").                  
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIToolbar&op=viewProperties"))
    ) ;    
    //-----View Node Properties
    addWebUnit(
      new ClickURLLinkUnit("ViewNodeProperties", "click on View Node Properties button").
      setURL("&uicomponent=UIToolbar&op=viewProperties").        
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPropertiesInfo&op=addProperty"))       
    ) ;      
    addWebUnit(
      new ClickURLLinkUnit("AddProperty", "click on Add Property button").
      setURL("&uicomponent=UIPropertiesInfo&op=addProperty").      
      addValidator(new ExpectFormIdValidator("propertyForm"))      
    ) ;            
    //Select property type
    addWebUnit(
      new SubmitFormUnit("SelectProperty", "click on save button").
      setFormId("propertyForm").
      setField("type","4").        
      setField("op","changeType")        
    ) ;
    //---------------Save Property    
    addWebUnit(
      new SubmitFormUnit("SaveProperty", "click on save button").
      setFormId("propertyForm").
      setField("name","property-test").  
      setField("type","1").
      setField("value","1000").
      setField("op","save").
      addValidator(new ExpectLinkWithURLValidator("&uicomponent=UIPropertiesInfo&op=addProperty"))      
    ) ;     
    //Select Drive
    addWebUnit(
      new ClickURLLinkUnit("SelectDrive", "select Drive button").
      setURL("&uicomponent=MainToolbar&op=selectDrive").                  
      addValidator(new ExpectTextValidator("Drives"))      
    ) ;           
  }                 
  public java.util.List getRequiredSuites() { 
    String[] roles = ["user"] ;
    return [new NewAccountSuite(), new UserLoginSuite("#{client.name}", "#{client.name}", roles)] ;
  }  
}